<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
	<style>
		html, body {
			height: 100%;
			margin: 0;
		}

		#container {
			height: 100%;
		}
	</style>
</head>
<body>
	<div id="container"></div>
	<script src="./dist/main.bundle.js"></script>
	<script>
		var editor = monaco.editor.create(document.getElementById('container'), {
			minimap: { enabled: false },
			automaticLayout: true,
			language: 'plaintext',
			readOnly: true,
			theme: 'vs-dark'
		});

		// from https://github.com/microsoft/monaco-editor/issues/1509
		monaco.languages.registerDocumentFormattingEditProvider('xml', {
			async provideDocumentFormattingEdits(model, options, token) {
				return [
					{
						range: model.getFullModelRange(),
						text: formatXml(model.getValue()),
					},
				];
			},
		});

		// from https://stackoverflow.com/questions/376373/pretty-printing-xml-with-javascript => https://jsfiddle.net/fbn5j7ya/
		function formatXml(xml, tab = '  ', nl = '\n') {
			let formatted = '', indent = '';

			//function assumes that text starts with '<' and ends with '>'.  slice(1, -1) => remove 1st char and last char.
			const nodes = xml.slice(1, -1).split(/>\s*</);

			if (nodes[0][0] == '?')
				formatted += '<' + nodes.shift() + '>' + nl;

			for (let i = 0; i < nodes.length; i++) {
				const node = nodes[i];
				if (node[0] == '/')
					indent = indent.slice(tab.length); // decrease indent

				formatted += indent + '<' + node + '>' + nl;

				if (node[0] != '/' && node[node.length - 1] != '/' && node.indexOf('</') == -1)
					indent += tab; // increase indent
			}

			// remove last new line so that formatted text ends with '>' otherwise re-applying formatXml will give bad result (extra '>' at end of file).
			return formatted.slice(0, -nl.length);
		}
	</script>
</body>
</html> 